from Framework import Controller
from Framework import templatepage
from Framework.PluginManager import DeclarePlugin
from cherrypy import expose, request  
from ConfigParser import ConfigParser
from QueryResponder import QueryResponder
from cherrypy.lib import static
import os.path

class IOVManagement(Controller):
    """Page uses iov_tag.tmpl template
    """
    def __init__(self,context):
        Controller.__init__(self,context,__file__)
        #self.__schemalist=['CMS_COND_ECAL','CMS_COND_CSC','CMS_COND_DT']
        #self.__oracleservicemap={'ORCOFF_PROD':'cms_orcoff','ORCON_PROD':'orcon','ORCOFF_DEV':'cms_orcoff_int2r'}
        #self.__frontierservicemap={'ORCOFF_PROD':'Frontier','ORCON_PROD':'FrontierOn','ORCOFF_DEV':'FrontierDev','ORCOFF_INT':'FrontierInt'}
        self.__schemalist=[]
        self.__oracleservicemap={}
        self.__frontierservicemap={}
        self.__taglist=''
        #template variable dict
        self.ret_dict={}
        self.ret_dict['service_dropdown'] = ''
        self.ret_dict['schema_dropdown'] = ''
        self.ret_dict['viacache'] = ''
        self.ret_dict['tag_list'] = ''
        self.ret_dict['payload'] = ''
        self.ret_dict['iov_list'] = ''
        self.ret_dict['iov_serv'] =''
        self.ret_dict['iov_det'] = ''
        self.ret_dict['file'] = ''
        #self.ret_dict['menu_contents'] = None
        self.ret_dict['error'] = None
        self.__basepath = __file__.rsplit('/', 1)[0]
        self.ret_dict['path'] = self.__basepath
        self.ret_dict['error'] = None
        #self.__page_list="{title:\"IOV tag management\",link:\"$basepath/conddb/IOVManagement\",label:\"IOV tag management\"},{title:\"SQLite data\",link:\"$basepath/DataDistribution\",label:\"DataDistribution\"}"
        self.__appurl=''
        self.__parseconfig()
        #self.ret_dict['menu_contents'] = self.__setMenu()
        
    def __parseconfig(self):
        configparser=ConfigParser()
        filename=os.path.join(self.__basepath,'conddbpage.conf')
        configparser.read(filename)
        self.__appurl=configparser.get('APPSERVER','baseurl')
        schemaliststr=configparser.get('SERVICEMAP','schema_list')
        schemaliststr=('').join(schemaliststr.split(' '))
        self.__schemalist=schemaliststr.upper().split(',')
        oracleservicemapstr=configparser.get('SERVICEMAP','oracleservice_map')
        oracleservicemapstr=('').join(oracleservicemapstr.split(' '))
        oracleservicelist=oracleservicemapstr.split(',')
        for item in oracleservicelist:
            field=item.split(':')
            self.__oracleservicemap[field[0]]=field[1]
        frontierservicemapstr=configparser.get('SERVICEMAP','frontierservice_map')
        frontierservicemapstr=('').join(frontierservicemapstr.split(' '))
        frontierservicelist=frontierservicemapstr.split(',')
        for item in frontierservicelist:
            field=item.split(':')
            self.__frontierservicemap[field[0]]=field[1]
        
    @expose
    def index(self):
        """Top level page. Show clean state
        """
        self.ret_dict['schema_dropdown']=self.__makeDropdownMenu('schema',self.__schemalist,None,None)
        self.ret_dict['service_dropdown']=self.__makeDropdownMenu('service',self.__oracleservicemap.keys(),None,None)
        return self.templatePage("iov_tag", self.ret_dict)
    
    @expose
    def get_tags(self, *args, **kwds):
        """Fill in the first form to list all available tags for a given service and schema combination
        """
        self.ret_dict['viacache'] = ''
        self.ret_dict['iov_det'] = ''
        self.ret_dict['iov_serv'] = ''
        self.ret_dict['tag_list'] = ''
        self.ret_dict['error'] = None
        self.ret_dict['schema_dropdown']=self.__makeDropdownMenu('schema',self.__schemalist,kwds['schema'],None)
        self.ret_dict['service_dropdown']=self.__makeDropdownMenu('service',self.__oracleservicemap.keys(),kwds['service'],None)
        self.ret_dict['iov_det'] = kwds['schema']
        self.ret_dict['iov_serv'] = kwds['service']
        trueservice=''
        if kwds.has_key('viacache') and kwds['viacache'] != '':
            self.ret_dict['viacache'] = 'CHECKED'
            trueservice = self.__frontierservicemap[ kwds['service'] ]
        else:
            self.ret_dict['viacache'] = ''
            trueservice = self.__oracleservicemap[ kwds['service'] ] 
        #print 'self.ret_dict[viacache]',self.ret_dict['viacache']
        self.__taglist=self.__prepareTagList(trueservice,kwds['schema'],self.ret_dict['viacache']);
        self.ret_dict['tag_list']=self.__taglist
        return self.templatePage("iov_tag", self.ret_dict)

    @expose	
    def get_iovs(self, *args, **kwds):
        """fill in the second form to display selected tag info and to save result to file. Can be called after get_tags
        """
        self.ret_dict['tag_list']=self.__taglist
        self.ret_dict['iov_list']=''
        self.ret_dict['error'] = None
        self.ret_dict['schema_dropdown']=self.__makeDropdownMenu('schema',self.__schemalist,kwds['schema'],None)
        self.ret_dict['service_dropdown']=self.__makeDropdownMenu('service',self.__oracleservicemap.keys(),kwds['service'],None)
        trueservice=''
        if kwds.has_key('viacache') and kwds['viacache'] != '':
            self.ret_dict['viacache'] = 'CHECKED'
            trueservice = self.__frontierservicemap[ kwds['service'] ]
        else:
            self.ret_dict['viacache'] = ''
            trueservice = self.__oracleservicemap[ kwds['service'] ]
        if kwds.has_key('sel_tag') is False:
            self.ret_dict['error'] = "Tag has to be selected"
            return self.templatePage("iov_tag", self.ret_dict)
        self.ret_dict['tag_list']=self.__selectTag(kwds['sel_tag'])
        if kwds.has_key('file'):
           if kwds['payload']=='':
               self.ret_dict['error'] = "Payload name is required"
               return self.templatePage("iov_tag", self.ret_dict)
           self.ret_dict['payload']=kwds['payload']
           qResp = QueryResponder(self.__appurl)
           tmplocation=qResp.getFile(kwds['sel_tag'],trueservice,kwds['schema'],self.ret_dict['viacache'],self.ret_dict['payload'])
           return static.serve_file(tmplocation,'application/x-download','attachment',os.path.basename(tmplocation))
    
        iov_list=self.__prepareIOVList(kwds['sel_tag'],trueservice,kwds['schema'],self.ret_dict['viacache'])        
        self.ret_dict['iov_list']=iov_list
        return self.templatePage("iov_tag", self.ret_dict)
            
    def __prepareTagList(self,trueservice,schemaname,viacache):
        """Ask list of all tags for a given service and schema from the application server 
        """
        liststr = ''
        qResp = QueryResponder(self.__appurl)
        list = qResp.getTags(trueservice,schemaname,viacache)
        for tag in list:
            liststr+='<option style="direction:ltr" value="'+tag+'">'+tag+'</option>'
        return liststr
        
    def __selectTag(self,tag):
        """replace the option list with selected tag highlighted
        """
        sel=self.__taglist
        selected = '<option style="direction:ltr" value="'+tag+'">'+tag+'</option>'
        replacement='<option selected="selected" value="'+tag+'">'+tag+'</option>'
        sel.replace(selected,replacement)
        return sel
    
    def __prepareIOVList(self,tag,trueservice,schemaname,viacache):
        """Get info of selected tag from app server
        """
        qResp = QueryResponder(self.__appurl)
        list = qResp.getIOVForTag(tag,trueservice,schemaname,viacache)
	#list='Tag hcal_gains_v1;PayloadContainerName HcalGainsRcd;since \t till \t payloadToken;1 \t  4294967295 \t [DB=7E4ED659-82A4-DA11-A0AC-000E0C5CE043][CNT=HcalGainsRcd][CLID=A069207D-22A2-1BAD-FD51-13613F781A97][TECH=00000B01][OID=00000007-00000000];Total # of payload objects: 1'	
        iovs = list.split(';')
        temp = iovs[1].split(' ')
        self.ret_dict['container'] = temp[1]
        #print self.ret_dict['container']
        iovs.pop()
        iovs.pop()
        list =''
        for ind, el in enumerate(iovs):
            if ind > 2:
                tmp = el.split(' \t ')
                list = '<tr>'
                nfield=0
                for field in tmp:
                    if field!='':
                      nfield+=1
                      if nfield<=2:
                        list += '<td class="iov_cell">'+field+'</td> '
                list+='</tr>'
        return list
                
    #def __setMenu(self):
    #    """construct top level menu bar 
    #    """
    #    menu ='<script> function footerMenuText(){return ['
    #    menu += self.__page_list
    #    menu += ']}</script>'
    #    return menu
     
    def __makeDropdownMenu(self,dropName,optionList,selected=None,style=None):
        drop ='<select name=\"'+dropName+'\"'
        if style!=None:
            drop += ' class=\"'+style+'\"';
        drop += '>'
        for obj in optionList:
            if selected==obj:
                drop += '<option SELECTED value="'+obj+'">'+obj+'</option>'
            else:
                drop += '<option value=\"'+obj+'\">'+obj+'</option>'
        drop+='</select>'
        return drop
		   
DeclarePlugin ("/Controllers/CondDB/IOVManagement", IOVManagement, {"baseUrl": "/IOVManagement"})
		  	
